org.apache.tomcat.util.net

## Class NioBlockingSelector.BlockPoller

- java.lang.Object
- - java.lang.Thread
  - - org.apache.tomcat.util.net.NioBlockingSelector.BlockPoller

All Implemented Interfaces:
  Runnable

Enclosing class:
  NioBlockingSelector

    protected static class NioBlockingSelector.BlockPoller
    extends Thread

### Nested Class Summary

### Nested classes/interfaces inherited from class java.lang.Thread

`Thread.State, Thread.UncaughtExceptionHandler`

### Field Summary

Fields
`protected ConcurrentLinkedQueue<Runnable>` `events`
`protected boolean` `run`
`protected Selector` `selector`
`protected AtomicInteger` `wakeupCounter`

### Fields inherited from class java.lang.Thread

`MAX_PRIORITY, MIN_PRIORITY, NORM_PRIORITY`

### Constructor Summary

Constructors
`protected` `NioBlockingSelector.BlockPoller()`

### Method Summary

Methods
`void` `add(NioEndpoint.KeyAttachment key, int ops, NioBlockingSelector.KeyReference ref)`
`void` `cancel(SelectionKey sk, NioEndpoint.KeyAttachment key, int ops)`
`void` `cancelKey(SelectionKey key)`
`void` `countDown(CountDownLatch latch)`
`void` `disable()`
`boolean` `events()`
`void` `remove(NioEndpoint.KeyAttachment key, int ops)`
`void` `run()`
`void` `wakeup()`

### Methods inherited from class java.lang.Thread

`activeCount, checkAccess, clone, countStackFrames, currentThread, destroy, dumpStack, enumerate, getAllStackTraces, getContextClassLoader, getDefaultUncaughtExceptionHandler, getId, getName, getPriority, getStackTrace, getState, getThreadGroup, getUncaughtExceptionHandler, holdsLock, interrupt, interrupted, isAlive, isDaemon, isInterrupted, join, join, join, resume, setContextClassLoader, setDaemon, setDefaultUncaughtExceptionHandler, setName, setPriority, setUncaughtExceptionHandler, sleep, sleep, start, stop, stop, suspend, toString, yield`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### run

    protected volatile boolean run

#### selector

    protected Selector selector

#### events

    protected ConcurrentLinkedQueue<Runnable> events

#### wakeupCounter

    protected AtomicInteger wakeupCounter

### Constructor Detail

#### NioBlockingSelector.BlockPoller

    protected NioBlockingSelector.BlockPoller()

### Method Detail

#### disable

    public void disable()

#### cancelKey

    public void cancelKey(SelectionKey key)

#### wakeup

    public void wakeup()

#### cancel

    public void cancel(SelectionKey sk,
              NioEndpoint.KeyAttachment key,
              int ops)

#### add

    public void add(NioEndpoint.KeyAttachment key,
           int ops,
           NioBlockingSelector.KeyReference ref)

#### remove

    public void remove(NioEndpoint.KeyAttachment key,
              int ops)

#### events

    public boolean events()

#### run

    public void run()

Specified by:
  `run` in interface `Runnable`
Overrides:
  `run` in class `Thread`

#### countDown

    public void countDown(CountDownLatch latch)